﻿using System;
using System.IO;
using System.Diagnostics;
using System.Text;

namespace Lesson14
{
    class Program
    {
        static void Main(string[] args)
        {
            string fileName = "\\input.txt";
            string filePath = Environment.CurrentDirectory + fileName;
            string[] words = File.ReadAllText(filePath).Split(' '); //34730
            string totalString = String.Empty;

            Stopwatch sw = new Stopwatch();
            sw.Start();
            PlusOperator(words);
            sw.Stop();

            Console.WriteLine(String.Format("PlusOperator: {0} ms", sw.ElapsedMilliseconds));

            sw.Restart();
            ConcatMethod(words);
            sw.Stop();

            Console.WriteLine(String.Format("ConcatMethod: {0} ms", sw.ElapsedMilliseconds));

            sw.Restart();
            FormatMethod(words);
            sw.Stop();

            Console.WriteLine(String.Format("FormatMethod: {0} ms", sw.ElapsedMilliseconds));

            sw.Restart();
            BuilderClass(words);
            sw.Stop();

            Console.WriteLine(String.Format("BuilderClass: {0} ms", sw.ElapsedMilliseconds));

            Console.ReadKey();
        }

        private static void PlusOperator(string[] words)
        {
            string totalString = String.Empty;
            foreach (string word in words)
            {
                totalString += word;
            }
        }

        private static void ConcatMethod(string[] words)
        {
            string totalString = String.Empty;
            foreach (string word in words)
            {
                totalString = String.Concat(totalString, word);
            }
        }

        private static void FormatMethod(string[] words)
        {
            string totalString = String.Empty;
            foreach (string word in words)
            {
                totalString = String.Format("{0}{1}", totalString, word);
            }
        }

        private static void BuilderClass(string[] words)
        {
            StringBuilder sb = new StringBuilder();
            foreach (string word in words)
            {
                sb.Append(word);
            }
            sb.ToString();
        }
    }
}
